\chapter{Results}
This chapter summarizes performance improvements and successful merge count results and also elaborates the advantages and limitations of the changes.

\section{Software overview}
This section contains an overview of software needed for most of the measurements.
%\subsection{Libraries and frameworks for testing}

\subsection{ftrace}
Tracing framework \verb|ftrace| listens to trace calls inside the Linux kernel. Specific trace calls can be exposed e.g. by the \verb|trace-cmd| command that interacts with the \verb|ftrace| tracer itself in the running kernel. %Specific call to show all relevant tracing info that was used to create these results is:  \break
%trace-cmd start -e vm\_expand\_merge -e vm\_pgoff\_merge -f 'updated > 0' -e vm\_av\_merge -f 'diff\_count > 0 || failed\_av\_count > 0 || failed\_pgoff\_count > 0 || same\_count > 0'

%trace-cmd start -e vm_pgoff_merge -f 'updated > 0' -e vm_av_merge -f 'same_count > 0 || diff_count > 0 || pgoff_failed_count > 0 || failed_count > 0'

\subsection{Running benchmarks}
All scripts and other files needed to measure the results are located\break in the attachment's \verb|sources/benchmark| directory. Most important is the\break \verb|sources/benchmark/README| file which contains step by step instructions to run the benchmarks. In order to measure the performance and merges for both modified and mainline versions, there are two sets of patches located in the \verb|sources/benchmark/patches| that both enable tracing. For a simple demonstration there is also a prepared virtual machine image, it is referenced from the \verb|sources/README| file.

\section{Device overview}
Device overview describes devices that are later referenced in individual tests. There are always two versions of the kernel used for measuring results. One is a mainline version and the other is the same version with applied patches. Specific versions for specific devices can be seen in \tableref{tbl:device_overview}.

%\begin{table}[H]
%\centering
%\begin{tabular}{|c|c|}
%\hline
% Name & Orion  \\ \hline
% Motherboard & ASROCK B450M Pro4 \\ \hline
% CPU & AMD Ryzen 5 3600 \\ \hline
% GPU & NVIDIA T600 4GB GDDR6 \\ \hline
% RAM & G.Skill Aegis 2x16GB 3200 MHz \\ \hline
% Disk & WD Blue SN570 1TB \\ \hline
% OS & Gentoo Linux \\ \hline
% Kernel & v5.18.3 \\ \hline
%\end{tabular}
%\caption{Device overview.}
%\label{tbl:device_overview}
%\end{table}

\begin{table}[H]
\centering
\footnotesize
\begin{tabular}{|c|c|c|}
\hline
 Name & Orion & Apollo  \\ \hline
 Motherboard & ASROCK B450M Pro4 & Dell Inspiron 15R 5521 \\ \hline
 CPU & AMD Ryzen 5 3600 (6 cores) & Intel Core i7-3517U (2 cores) \\ \hline
 GPU & NVIDIA T600 4GB GDDR6 & AMD Radeon HD 8730M \\ \hline
 RAM & G.Skill Aegis 2x16GB 3200 MHz & Samsung SODIMM 2x4GB 1600MHz \\ \hline
 Disk & WD Blue SN570 1TB & Samsung SSD 850 EVO 500GB \\ \hline
 OS & Gentoo Linux & Gentoo Linux \\ \hline
 Kernel & v5.18.10 & v5.18.0 \\ \hline
\end{tabular}
\caption{Device overview.}
\label{tbl:device_overview}
\end{table}

\section{Performance and merge success rate results}
These tests measure performance and number of successful merges compared to mainline version. Results are used to calculate confidence intervals using confidence level 95 \% and presuming normal distribution. All measured times are in seconds.

%Then force swap (using either madvise's pageout or just consuming more memory) some of the blocks and see how fast it was in both version. Should produce measurable speed up.

%\subsubsection{Memory effectiveness}
%The spacing speed test can also be used to measure memory effectiveness, because one large merged block should consume less memory compared to many small blocks with lots of supporting structures.

%\gls{todo} Table with memory effectiveness results.

\subsection{New merge opportunities}

As the following benchmark results show, there can be quite a lot of new merges when it is possible to merge two \gls{vma}s with different \gls{av}s, even if only for the simpler case where physical pages are not shared. Originally, the motivation was to increase the number of merges during \verb|mremap()|, specifically in the \verb|copy_vma()| function, but the introduced changes enable more merges even for \verb|mmap()|, \verb|mprotect()| and other system calls modifying mapping's flags.

\bigbreak

In the case of \verb|mmap()|, opportunity arises when a newly created VMA fills a hole between two other VMAs. The newly created VMA itself has not been faulted and therefore has no AV linked to it, but the two neighbouring VMAs might be linked to different AVs and hence we get a merge situation involving two different \gls{av}s.

\bigbreak

In the case of \verb|mremap()|, new merge can happen when an already-existing VMA is moved next to or between two other VMAs. This merge situation involves up to three different VMAs with up to three different \gls{av}s.

\bigbreak

In the case of \verb|mprotect()|, \verb|madvise()|, \verb|mlock()| and \verb|mbind()|, the opportunity arises when an already-existing VMA's protection is modified and merging with one or two neighbouring VMAs is possible. This merge situation involves up to three different VMAs with up to three different AVs.

\bigbreak

In the case of \verb|brk()| syscall, new merge can happen when we decide to expand an already-existing mapping during \verb|do_brk_flags()| and call \verb|vma_merge()| to do so. If the expansion causes the expanded mapping to become adjacent to another VMA, we again get a merge situation with possibly two different AVs.

\subsection{Spacing speed test}
This test performs VMA merging for VMAs linked to different or the same AVs. It creates memory mappings with spaces between them and then moves the mappings together. The mappings will merge into one big mapping if it is supported by the kernel. Only the actual moving and merging of the mappings is measured, the creation of the mappings and spaces is not. The Spacing speed test takes two arguments, the number of mappings to create and if they should have different or the same AV. The results are displayed in \tableref{tbl:spacing_speed_results_a} and \tableref{tbl:spacing_speed_results_b}.

%\begin{table}[H]
%\centering
%\begin{tabular}{|c|c|c|c|c|c|c|}
%\hline
% platform & \#VMAs & diff AV & faulted & time & diff m. & pgoff m. \\ \hline
 %Orion & 20000 & same & no & ~3.4s & - & - \\ \hline
 %Orion & 20000 & diff & no & ~1.1s & - & - \\ \hline
 %patched Orion & 20000 & same & no & ~1.6s & 0 & ??? \\ \hline
 %patched Orion & 20000 & diff & no & ~1.1s & 0 & 0 \\ \hline
% Orion & 20000 & same & yes & ~3.4s & - & - \\ \hline
% Orion & 20000 & diff & yes & ~3.4s & - & - \\ \hline
% patched Orion & 20000 & same & yes & ~1.8s & 0 & 19999 \\ \hline
% patched Orion & 20000 & diff & yes & ~1.8s & 20000 & 20000 \\ \hline
 %Apollo & 20000 & same & yes & ~3.4s & - & - \\ \hline
 %Apollo & 20000 & diff & yes & ~3.4s & - & - \\ \hline
 %patched Apollo & 20000 & same & yes & ~2.6s & 0 & 19994 \\ \hline
 %patched Apollo & 20000 & diff & yes & ~2.4s & 20000 & 19995 \\ \hline
%\end{tabular}
%\caption{Results for Spacing speed test.}
%\label{tbl:spacing_speed_results}
%\end{table}

\begin{table}[H]
\centering
\begin{tabular}{|c|c|C{1.2cm}|c|C{1.2cm}|c|}
\hline
 platform & AV & times & CI (95 \%) & diff m. & CI (95 \%) \\ \hline
 Apollo & same & 5.51s, 5.38s, 5.50s & 5.40–5.53 & 0, 0, 0 & 0\\ \hline
 p. Apollo & same & 2.57s, 2.64s, 2.65s & 2.58–2.66 & 0, 0, 0 & 0 \\ \hline
 Apollo & diff & 5.53s, 5.52s, 5.52s & 5.52–5.53 & 0, 0, 0 & 0 \\ \hline
 p. Apollo & diff & 2.53s, 2.52s, 2.55s & 2.52–2.55 & 20000, 20000, 20000 & 20000 \\ \hline
 Orion & same & 3.41s, 3.36s, 3.37s & 3.36–3.40 & 0, 0, 0 & 0\\ \hline
 p. Orion & same & 1.65s, 1.66s, 1.67s & 1.65–1.67 & 1, 0, 0 & -0.20–0.87\\ \hline
 Orion & diff & 3.44s, 3.41s, 3.49s & 3.41–3.48 & 0, 0, 0 & 0\\ \hline
 p. Orion & diff & 1.65s, 1.65s, 1.67s & 1.65–1.67 & 20000, 20000, 20000 & 20000 \\ \hline
 
\end{tabular}
\caption{Results for Spacing speed test with 20000 mappings (part A)}
\label{tbl:spacing_speed_results_a}
\end{table}

\begin{table}[H]
\centering
\begin{tabular}{|c|c|C{1.2cm}|c|C{1.2cm}|c|}
\hline
 platform & AV & pgoff m. & CI (95 \%) & failed m. & CI (95 \%) \\ \hline
 Apollo & same & 0, 0, 0 & 0 & 40018, 40018, 40018 & 40018 \\ \hline
 p. Apollo & same & 19989, 19989, 19989 & 19989 & 0, 0, 0 & 0 \\ \hline
 Apollo & diff & 0, 0, 0 & 0 & 40018, 40018, 40018 & 40018 \\ \hline
 p. Apollo & diff & 19989, 19989, 19989 & 19989 & 0, 0, 0 & 0 \\ \hline
 Orion & same & 0, 0, 0 & 0 & 40018, 40024, 40022 & 40019–40024\\ \hline
 p. Orion & same & 19996, 19992, 19992 & 19991–19996 & 1, 0, 0 & -0.2–0.9 \\ \hline
 Orion & diff & 0, 0, 0 & 0 & 40024, 40022, 40026 & 40022–40026 \\ \hline
 p. Orion & diff & 19995, 19989, 19994 & 19990–19996 & 20000, 20000, 20000 & 20000 \\ \hline
 
\end{tabular}
\caption{Results for Spacing speed test with 20000 mappings (part B)}
\label{tbl:spacing_speed_results_b}
\end{table}

%\begin{table}[H]
%\centering
%\small
%\begin{tabular}{|c|c|c|c|c|}
%\hline
%platform & Apollo & Apollo & patched Apollo & patched Apollo\\ \hline
%diff AV & same & diff & same & diff\\ \hline
%times & 5.51, 5.38, 5.50 & 5.53, 5.52, 5.52 & 2.57, 2.64, 2.65 & 2.53, 2.52, 2.55\\ \hline
%CI (95 \%) & 5.40-5.53 & 5.52-5.53 & 2.58-2.66 &  2.52-2.55 \\ \hline
%diff m. & 0, 0, 0 & 0, 0, 0 & 0, 0, 0 & 20000, 20000, 20000\\ \hline
%CI (95 \%) & 0 & 0 & 0 & 20000\\ \hline
%pgoff.m & 0 & 0 & 19989, 19989, 19989 & 19989, 19989, 19989\\ \hline
%CI (95 \%) & 0 & 0 & 19989 & 19989\\ \hline
%failed m. & 40018, 40018, 40018 & 40018, 40018, 40018 & 0, 0, 0 & 0, 0, 0\\ \hline
%CI (95 \%) & 40018 & 40018 & 0 & 0\\ \hline
%\end{tabular}
%\caption{Apollo results for Spacing speed test with 20000 mappings.}
%\label{tbl:spacing_speed_results}
%\end{table}

\subsection{jemalloc stress tests}
The \verb|jemalloc| is a general purpose allocator trying to promote fragmentation avoidance and scalable concurrency support. It is used by the Firefox browser and others. In order to verifiably measure the number of merge counts, \verb|jemalloc| self-tests were used.
\bigbreak
The source files can be downloaded from the jemalloc's GitHub repository\footnote{Jemalloc releases - \url{https://github.com/jemalloc/jemalloc/releases}}. After unzipping the folder, continue with \verb|./configure|, \verb|make| and then e.g.\break \verb|gmake tests_stress|.

\subsubsection{Results}
The results can be seen in \tableref{tbl:jemalloc_results_a} and \tableref{tbl:jemalloc_results_b}. \verb|Jemalloc| version 5.3.0 was used.
%\begin{table}[H]
%\centering
%\begin{tabular}{|c|c|c|c|c|c|c|c|}
%\hline
% test & platform & time & sys t. & diff m. & pgoff m. & failed m. \\ \hline \hline
% unit & Orion & ~118.4s & ~14.9s & ~0 & 0 & 775.3 \\ \hline
% integration & Orion & ~57.0s & ~6.0s & 0 & 0 & 426 \\ \hline
% analyze & Orion & ~53.6s & ~5.7s & ~0 & ~0 & 473.3 \\ \hline
% stress & Orion & ~107.0s & ~10.5s & ~0 & ~0 & 902 \\ \hline
% unit & patched Orion & ~117.8s & ~13.9s & ~459 & 345 & 30 \\ \hline
% integration & patched Orion & ~56.9s & ~6.0s & ~309 & 8 & 3 \\ \hline
% analyze & patched Orion & ~53.7s & ~5.5s & ~272 & ~0 & 0 \\ \hline
% stress & patched Orion & ~107.1s & ~10.5s & ~527 & ~0 & 0 \\ \hline
% %unit & patched Apollo & ~221.9s & ~24.2s & ~459 & 345 & 30 \\ \hline
% %integration & patched Apollo & ~109.1s & ~10.6s & ~309 & 8 & 3 \\ \hline
% %analyze & patched Apollo & ~102.9s & ~9.5s & ~272 & ~0 & 0 \\ \hline
% %stress & patched Apollo & ~204.1s & ~18.9s & ~527 & ~0 & 0 \\ \hline
%\end{tabular}
%\caption{Stress tests results for jemalloc.}
%\label{tbl:jemalloc_results}
%\end{table}

\begin{table}[H]
\centering
\small
\begin{tabular}{|c|c|c|c|c|c|}
\hline
 test & platform & times & CI (95 \%) & diff m. & CI (95 \%) \\ \hline \hline
 unit & Apollo & 238.9, 238.7, 238.4 & 238.4–238.9 & 0, 0, 0 & 0 \\ \hline
 unit & p. Apollo & 240.0, 239.4, 239.1 & 239.1–239.9 & 460, 460, 460 & 460  \\ \hline
 integ. & Apollo & 114.0, 114.3, 114.3 & 114.0–114.4 & 0, 0, 0 & 0  \\ \hline
 integ. & p. Apollo & 114.6, 114.6, 114.9 & 114.5–114.9 & 310, 310, 310 & 310  \\ \hline
 analyze & Apollo & 107.4, 107.6, 107.5 & 107.4–107.6 & 0, 0, 0 & 0  \\ \hline
 analyze & p. Apollo & 107.8, 107.8, 107.7 & 107.7–107.8 & 274, 274, 274 & 274 \\ \hline
 stress & Apollo & 212.4, 212.8, 213.0 & 212.5–213.0 & 0, 0, 0 & 0  \\ \hline
 stress & p. Apollo & 213.6, 213.9, 213.4 & 213.4–213.9 & 530, 530, 530 & 530\\ \hline
 unit & Orion & 129.9, 130.2, 130.6 & 129.9–130.6 & 0, 0, 0 & 0 \\ \hline
 unit & p. Orion & 131.3, 131.5, 131.2 & 131.2–131.5 & 487, 492, 498 & 487–497 \\ \hline
 integ. & Orion & 61.5, 61.3, 61.2 & 61.2–61.5 & 0, 0, 0 & 0  \\ \hline
 integ. & p. Orion & 61.9, 62.3, 61.6 & 61.6–62.3 & 317, 319, 322 & 317–322 \\ \hline
 analyze & Orion & 57.7, 57.3, 58.0 & 57.3–58.0 & 0, 0, 0 & 0 \\ \hline
 analyze & p. Orion & 58.1, 58.4, 58.5 & 58.1–58.5 & 274, 285, 293 & 275–293  \\ \hline
 stress & Orion & 113.8, 115.0, 114.2 & 113.8–114.9 & 0, 0, 0 & 0 \\ \hline
 stress & p. Orion & 115.7, 115.9, 115.5 & 115.5–115.9 & 546, 552, 563 & 546–562 \\ \hline
\end{tabular}
\caption{Stress tests results for jemalloc (part A)}
\label{tbl:jemalloc_results_a}
\end{table}

\begin{table}[H]
\centering
\small
\begin{tabular}{|c|c|c|c|c|c|}
\hline
 test & platform & pgoff m. & CI (95 \%) & failed m. & CI (95 \%) \\ \hline \hline
 unit & Apollo & 0, 0, 0  & 0  & 460, 460, 460 & 460\\ \hline
 unit & p. Apollo & 0, 0, 0 & 0 & 0, 0, 0 & 0 \\ \hline
 integration & Apollo & 0, 0, 0 & 0 & 310, 310, 310 & 310 \\ \hline
 integration & p. Apollo & 0, 0, 0 & 0 & 0, 0, 0 & 0 \\ \hline
 analyze & Apollo & 0, 0, 0 & 0 & 274, 274, 274 & 274 \\ \hline
 analyze & p. Apollo & 0, 0, 0 & 0 & 0, 0, 0 & 0\\ \hline
 stress & Apollo & 0, 0, 0 & 0 & 530, 530, 531 & 530–531 \\ \hline
 stress & p. Apollo & 0, 0, 0 & 0 & 0, 0, 0 & 0\\ \hline
 unit & Orion & 0, 0, 0  & 0 & 1368, 1276, 1450 & 1284–1445\\ \hline
 unit & p. Orion & 352, 376, 439 & 347–431 & 67, 67, 74 & 66–73 \\ \hline
 integration & Orion & 0, 0, 0  & 0 & 637, 645, 689 & 631–683  \\ \hline
 integration & p. Orion & 168, 150, 178 & 152–178 & 35, 28, 30 & 28–34 \\ \hline
 analyze & Orion & 0, 0, 0  & 0 & 624, 648, 664 & 626–664 \\ \hline
 analyze & p. Orion & 164, 158, 183 & 156–180 & 24, 22, 28 & 22–27 \\ \hline
 stress & Orion & 0, 0, 0  & 0 & 1308, 1264, 1290 & 1267–1308 \\ \hline
 stress & p. Orion & 312, 306, 365 & 298–358 & 61, 44, 39 & 37–59\\ \hline
\end{tabular}
\caption{Stress tests results for jemalloc (part B)}
\label{tbl:jemalloc_results_b}
\end{table}

\subsection{Redis}
\verb|Redis| is an open source in-memory database. As such, it works quite extensively with memory. \verb|Redis| self-tests were used to measure the results. Running the test is quite easy, all you have to do is run \verb|make| and then \verb|./runtest|.

\subsubsection{Results}
The results are summarized in \tableref{tbl:redis_results_a} and \tableref{tbl:redis_results_b}. \verb|Redis| version 7.0.2, which was used to run the test, is available at Github\footnote{Redis releases - \url{https://github.com/redis/redis/releases}}. 
%\begin{table}[H]
%\centering
%\begin{tabular}{|c|c|c|c|c|c|c|c|}
%\hline
% test & platform & time & sys t. & diff m. & pgoff m. & failed m. \\ \hline \hline
% Redis & Orion & ~83.9s & ~41.8s & ~0 & 0 & 400 \\ \hline
% Redis & patched Orion & ~85.5s & ~32.9s & ~700 & 37 & 6 \\ \hline
% %Redis & patched Apollo & ~0.8s & ~0.8s & ~700 & 37 & 6 \\ \hline
%\end{tabular}
%\caption{Stress tests results for Redis.}
%\label{tbl:redis_results}
%\end{table}

\begin{table}[H]
\centering
\begin{tabular}{|c|c|c|c|c|}
\hline
 platform & times & CI (95 \%) & diff m. & CI (95 \%) \\ \hline \hline
 Apollo & 394.3, 398.8, 397.5  & 394.7–399.0 & 0, 0, 0  & 0  \\ \hline
 patched Apollo & 395.6, 393.2, 393.0 & 392.6–395.3 & 2, 1, 2 & 1–2\\ \hline
 Orion & 498.8, 499.0, 499.1 & 498.8–499.1 & 0, 0, 0 & 0   \\ \hline
 patched Orion & 499.0, 498.8, 498.8 & 498.8–499.0 &  1, 3, 1 & 1–3 \\ \hline
\end{tabular}
\caption{Stress tests results for Redis (part A)}
\label{tbl:redis_results_a}
\end{table}

\begin{table}[H]
\centering
\begin{tabular}{|c|c|c|c|c|}
\hline
 platform & pgoff m. & CI (95 \%) & failed m. & CI (95 \%) \\ \hline \hline
 Apollo & 0, 0, 0 & 0 & 41, 59, 44 & 39–57 \\ \hline
 patched Apollo & 20, 19, 29 & 18–28 & 1, 0, 0 & 0–1\\ \hline
 Orion & 0, 0, 0 & 0 & 36, 34, 26 & 27–37 \\ \hline
 patched Orion & 15, 13, 18 & 13–18 & 5, 7, 10 & 5–10 \\ \hline
\end{tabular}
\caption{Stress tests results for Redis (part B)}
\label{tbl:redis_results_b}
\end{table}

\subsection{kcbench}
The \verb|kcbench| is a simple benchmark script that takes given kernel source files and compiles them several times using a different number of threads to thoroughly measure the compile times.

\subsubsection{Results}
The test is again run on patched and unpatched kernel, performance results are in \tableref{tbl:kcbench_speed} and merge count results are in \tableref{tbl:kcbench_merge_a} and \tableref{tbl:kcbench_merge_b}. It is also important to specify the kernel version used as the input source files for the compilation. In our case it was version v5.18\footnote{Linus's git repository - \url{https://github.com/torvalds/linux/releases/tag/v5.18}}. The used \verb|kcbench| version v0.9.5 is available at GitLab\footnote{Kcbench releases - \url{https://gitlab.com/knurd42/kcbench/-/releases}}.

%\begin{table}[H]
%\centering
%\begin{tabular}{|c|c|c|}
%\hline
% threads & Orion & patched Orion \\ \hline \hline
% 6 & 178.12s & 178.70s \\ \hline
% 6 & 177.84s & 178.39s \\ \hline
% 9 & 155.23s & 155.29s \\ \hline
% 9 & 155.29s & 155.53s \\ \hline
% 12 & 136.59s & 136.84s \\ \hline
% 12 & 136.58s & 136.68s \\ \hline
% 15 & 137.60s & 137.65s \\ \hline
% 15 & 137.54s & 137.64s \\ \hline
%\end{tabular}
%\caption{Performance results for patched and unpatched Orion.}
%\label{tbl:kcbench_speed_orion}
%\end{table}

\begin{table}[H]
\centering
\begin{tabular}{|c|c|C{3.4cm}|c|c|}
\hline
 threads & platform & measured times & CI (95 \%)  \\ \hline \hline
 2 & Apollo & 1080.49, 1080.25, 1080.13, 1080.62, 1080.62, 1081.31  & 1080.27–1080.87 \\ \hline
 2 & patched Apollo & 1090.04, 1090.09, 1090.72, 1090.76, 1089.80, 1089.68 & 1089.85–1090.52 \\ \hline
 4 & Apollo  & 911.75, 911.48, 912.07, 911.27, 911.51, 912.30 & 911.44–912.02 \\ \hline
 4 & patched Apollo & 921.08, 920.67, 920.11, 920.67, 920.24, 919.52 & 919.98–920.78  \\ \hline
 6 & Apollo  & 918.25, 918.55, 918.74, 918.19, 918.44, 918.56 & 913.30–918.61  \\ \hline
 6 & patched Apollo & 928.60, 927.92, 928.41, 927.44, 928.36, 928.31 & 927.86–928.48   \\ \hline
 6 & Orion & 180.29, 180.28, 181.05, 180.61, 181.34, 181.51 & 180.46–181.23  \\ \hline
 6 & patched Orion & 184.08, 183.81, 183.73, 183.84, 183.82, 183.42 & 183.63–183.94 \\ \hline
 9 & Orion & 156.60, 156.58, 156.98, 157.66, 157.36, 157.57 & 156.78–157.47  \\ \hline
 9 & patched Orion & 158.86, 158.83, 158.99, 158.90, 158.97, 158.86 & 158.85–158.95 \\ \hline
 12 & Orion & 137.59, 137.89, 138.06, 138.49, 138.97, 138.62 & 137.90–138.65  \\ \hline
 12 & patched Orion & 139.65, 139.42, 139.33, 139.58, 139.27, 139.36 & 139.33–139.54  \\ \hline
 15 & Orion & 138.72, 138.82, 139.51, 139.34, 139.23, 139.01 &  138.88–139.33 \\ \hline
 15 & patched Orion & 140.39, 140.50, 140.23, 140.33, 140.31, 140.13 & 140.22–140.41  \\ \hline
\end{tabular}
\caption{Performance results for kcbench.}
\label{tbl:kcbench_speed}
\end{table}

%\begin{table}[H]
%\centering
%\begin{tabular}{|c|c|c|}
%\hline
% threads & Apollo & patched Apollo\\ \hline \hline
% 2 & ??? & 1078.91s \\ \hline
% 2 & ??? & 1079.28s \\ \hline
% 4 & ??? & 909.45s \\ \hline
% 4 & ??? & 909.37s \\ \hline
% 6 & ??? & 916.19s \\ \hline
% 6 & ??? & 915.92s \\ \hline
%\end{tabular}
%\caption{Performance results for patched and unpatched Apollo.}
%\label{tbl:kcbench_speed_apollo}
%\end{table}

\begin{table}[H]
\centering
\begin{tabular}{|c|c|c|c|c|}
\hline
 platform & diff m. & CI (95 \%) & pgoff m. & CI (95 \%)  \\ \hline
 Apollo & 0, 0, 0 & 0 & 0, 0, 0 & 0\\ \hline
 p. Apollo & 19964, 19964, 19964 & 19964 & 245, 245, 245 & 245 \\ \hline
 Orion & 0, 0, 0 & 0 & 0, 0, 0 & 0 \\ \hline
 p. Orion & 23900, 23896, 23897 & 23896–23900.0 & 347, 348, 344 & 344–348 \\ \hline
\end{tabular}
\caption{Kcbench merge results (part A)}
\label{tbl:kcbench_merge_a}
\end{table}

\begin{table}[H]
\centering
\begin{tabular}{|c|c|c|c|c|}
\hline
 platform & expand & CI (95 \%) & failed m. & CI (95 \%) \\ \hline
 Apollo & 0, 0, 0 & 0 & 20777, 20776, 20776 & 20776–20777\\ \hline
 p. Apollo & 7, 7, 7 & 7 & 98, 98, 98 & 98 \\ \hline
 Orion & 0, 0, 0 & 0 & 25018, 25029, 25026 & 25019–25030\\ \hline
 p. Orion & 9, 9, 9 & 9 & 178, 179, 175 & 175–179 \\ \hline
\end{tabular}
\caption{Kcbench merge results (part B)}
\label{tbl:kcbench_merge_b}
\end{table}

\subsubsection{Comparison}
The \verb|kcbench| results are probably most indicative to compare the patched and unpatched versions and their performance. Upper and lower bounds of confidence intervals are used to calculate a possible minimal and maximal slow down. E.g. for a–b mainline CI and c–d patched CI the comparison is calculated as \( \frac{c}{b} \) – \( \frac{d}{a} \)\%. We can see that the patched kernel in this scenario is slower by 0.5–2 \%, as can be seen in the \tableref{tbl:kcbench_comparison}.

\begin{table}[H]
\centering
\begin{tabular}{|c|c|c|c|c|}
\hline
 platform & threads & mainline CI & patched CI & comparison \\ \hline
 Apollo & 2 & 1080.27–1080.87 & 1089.85–1090.52 & 100.831–100.949 \% \\ \hline   
 Apollo & 4 & 911.44–912.02 & 919.98–920.78 & 100.873–101.025 \% \\ \hline   
 Apollo & 6 & 913.30–918.61 & 927.86–928.48 & 101.007–101.662 \% \\ \hline   
 Orion & 6 & 180.46–181.23 & 183.63–183.94 & 101.324–101.928 \% \\ \hline   
 Orion & 9 & 156.78–157.47 & 158.85–158.95 & 100.876–101.384 \% \\ \hline   
 Orion & 12 & 137.90–138.65 & 139.33–139.54 & 100.490–101.189 \% \\ \hline   
 Orion & 15 & 138.88–139.33 & 140.22–140.41 & 100.639–101.102 \% \\ \hline  
\end{tabular}
\caption{Kcbench comparison.}
\label{tbl:kcbench_comparison}
\end{table}

\pagebreak

\section{Evaluation}
As can be deducted from results above benchmark result from Apollo are much more compact than those from Orion. This is probably some interference from other applications running on Orion.
\bigbreak
The benchmarks confirm that most of the cases where merging is not possible in the mainline kernel are resolved by this patch series, solving more than 90\% of the cases. It also turns out that allowing different AV merging alone (not in combination with page offset update) is responsible for the vast majority of the newly possible merges. The changes have a small impact on the performance. 
\bigbreak
However, each workload behaves differently and even small changes in benchmarked application or choosing different application at all might produce different results. Developers usually do not deal with memory mappings alignment directly and therefore most of the merge opportunities depend on interactions between compilers, libraries and the kernel itself.

\section{Advantages}
In the current kernel, merges of anonymous mappings are mostly limited to VMAs that are either newly created (and therefore it is practically just an expand of an already existing area) or those that are created standalone but not yet faulted and therefore easier to merge. This basically means that any VMA that has been written to and then moved can never merge with anything because the page offset will not match its virtual address. And additionally, even if the page offset is correct, the merge can fail because of the AVs not being identical for both VMAs.
\bigbreak
All of the above has been solved in this thesis and implemented in the attached code. This means that the number of VMAs is decreased and the virtual memory is more compact, which simplifies certain operations that must traverse the VMAs. There is also a limited number of VMAs that can exist for one process, which is defined as \verb|DEFAULT_MAX_MAP_COUNT| and is almost equal (with some margin) to unsigned short max value, which is 65535. This is a lot of mappings and for most processes with common memory allocation patterns it is practically unlimited. A typical process usually stores its data in heap and stack which amounts for two quite big areas and maybe a few file mappings. But it is not that hard to waste all the mappings if you want to or if this is a side effect of your code. In fact, with the smallest possible areas of 4096 bytes, it would only take around 255 MB of memory to reach the limit. That might seem like intentionally pushing kernel to its limits, but imagine you do not have just a few or tenths of gigabytes but rather terabytes of memory on some special-purpose server that relies on creating and moving VMAs, for example in a large database, then even with quite big VMAs the limit might run away pretty quickly.
\bigbreak
Another added bonus is from a formal point of view. Anonymous VMAs have page offsets calculated as virtual address with removed page bits, this means shifting the virtual address by \verb|PAGE_SHIFT|. When it is moved, the page offset in the mainline kernel stays the same and does not match the address any more, although it still matches the VMA's page offset (also immutable) needed for \fullref{sec:rmap_walk}. This is obviously wrong and also confusing not only for new users trying to find a bug or just simply trying to understand the code. And although cosmetic, even this can be viewed as added benefit.

\section{Limitations}
Updating page offset during \verb|mremap()| costs some time. Also, if merge conditions are met and actual merge happens, this also takes some time and as a consequence the kernel as a whole can be a bit slower. On the other hand, this is slightly compensated by the decreased number of VMAs present, which speeds up some walks e.g. during \fullref{sec:rmap_walk}.

\bigbreak
Another limitation is the impossibility to merge VMAs that are shared among several processes. This is unfortunately a hard stop because pages have AV pointer stored in them and can therefore belong only to one AV. A merge would imply that the page could belong to two different AVs for two different processes, which is impossible. It could be solved by duplicating the physical page itself, but that would waste memory and time in case of private \gls{cow} pages and actually break the shared concept for shared pages.